#ifndef CRITBIT_H_
#define CRITBIT_H_

#ifdef __cplusplus
extern "C" {
#endif

/* for ATTR_PURE if we are compiling under dietlibc */
#include <stddef.h>

#ifndef ATTR_PURE
#  if defined __has_attribute
#    if __has_attribute (pure)
#      define ATTR_PURE __attribute__ ((pure))
#    endif
#  endif
#endif
#ifndef ATTR_PURE
#  define ATTR_PURE
#endif

typedef struct {
  void *root;
} critbit0_tree;

int critbit0_contains(critbit0_tree *t, const char *u) ATTR_PURE;
int critbit0_insert(critbit0_tree *t, const char *u);
int critbit0_delete(critbit0_tree *t, const char *u);
void critbit0_clear(critbit0_tree *t);
int critbit0_allprefixed(critbit0_tree *t, const char *prefix,
                         int (*handle) (const char *, void *), void *arg);

#ifdef __cplusplus
};
#endif

#endif
